/*--- groeperen van alle B/M/V locaties ---*/

DEF VAR cLetter     AS CHAR NO-UNDO.
DEF VAR cGroup      AS CHAR NO-UNDO.
DEF VAR cShortname1 AS CHAR NO-UNDO.
DEF VAR cShortname2 AS CHAR NO-UNDO.
DEF VAR cShortname3 AS CHAR NO-UNDO.
DEF VAR iStelling   AS INT  NO-UNDO.

DEFINE BUFFER b1-wm-loc_stack FOR wm-loc_stack.
DEFINE BUFFER b2-wm-loc_stack FOR wm-loc_stack.

FOR EACH b1-wm-loc_stack NO-LOCK:
  cGroup  = SUBSTRING(b1-wm-loc_stack.shortname,1, LENGTH(b1-wm-loc_stack.shortname) - 1).
  cLetter = SUBSTRING(b1-wm-loc_stack.shortname,LENGTH(b1-wm-loc_stack.shortname),1).
  IF cLetter = "B"
  THEN DO:
    cShortname1 = cGroup + "B".
    cShortname2 = cGroup + "M".
    cShortname3 = cGroup + "V".
    
    IF CAN-FIND(b2-wm-loc_stack WHERE
                b2-wm-loc_stack.companycode = b1-wm-loc_stack.companycode AND
                b2-wm-loc_stack.shortname   = cShortname1)
    AND CAN-FIND(b2-wm-loc_stack WHERE
                 b2-wm-loc_stack.companycode = b1-wm-loc_stack.companycode AND
                 b2-wm-loc_stack.shortname   = cShortname2)
    AND CAN-FIND(b2-wm-loc_stack WHERE
                 b2-wm-loc_stack.companycode = b1-wm-loc_stack.companycode AND
                 b2-wm-loc_stack.shortname   = cShortname3)
    THEN DO TRANSACTION:
      iStelling = iStelling + 1. 
      FIND b2-wm-loc_stack WHERE
           b2-wm-loc_stack.companycode = b1-wm-loc_stack.companycode AND
           b2-wm-loc_stack.shortname   = cShortname1
           EXCLUSIVE-LOCK.
      ASSIGN b2-wm-loc_stack.loc_groupcode = cGroup.     
      FIND b2-wm-loc_stack WHERE
           b2-wm-loc_stack.companycode = b1-wm-loc_stack.companycode AND
           b2-wm-loc_stack.shortname   = cShortname2
           EXCLUSIVE-LOCK.
      ASSIGN b2-wm-loc_stack.loc_groupcode = cGroup.     
      FIND b2-wm-loc_stack WHERE
           b2-wm-loc_stack.companycode = b1-wm-loc_stack.companycode AND
           b2-wm-loc_stack.shortname   = cShortname3
           EXCLUSIVE-LOCK.
      ASSIGN b2-wm-loc_stack.loc_groupcode = cGroup.     
    END. /*--- transaction ---*/
  END. /*--- if "B" ---*/
END. /*--- FOR EACH ---*/


/*--- altijd een een group aanmaken ---*/
FOR EACH wm-loc_stack WHERE wm-loc_stack.loc_groupcode = ""
         EXCLUSIVE-LOCK:
  wm-loc_stack.loc_groupcode = wm-loc_stack.shortname.
END.



