DEF VAR iAttachment               AS INTEGER   NO-UNDO.
DEF VAR cFilename                 AS CHARACTER NO-UNDO.
DEF VAR cExtension                AS CHARACTER NO-UNDO.
DEF VAR cTargetFile               AS CHARACTER NO-UNDO.
DEF VAR cOrgFile                  AS CHARACTER NO-UNDO.
DEF VAR cRecordType               AS CHARACTER NO-UNDO.
DEF VAR iSeqnr                    AS INTEGER   NO-UNDO.
DEF VAR iBlobnr                   AS INTEGER   NO-UNDO.
DEF VAR cWarnings                 AS CHAR      NO-UNDO.
DEF VAR cSubFolder                AS CHAR      NO-UNDO.
DEF VAR cSavePath                 AS CHAR      NO-UNDO.

DEF BUFFER b-aa-attachment FOR aa-attachment.

FOR EACH wm-image NO-LOCK BREAK BY companycode:
  IF FIRST-OF(companycode)
  THEN DO:
    FIND wm-parameter NO-LOCK  WHERE
         wm-parameter.companycode = wm-image.companycode.
    cSavePath = REPLACE(wm-parameter.image_path,"\","/").
    IF   cSavePath <> ""
     AND SUBSTRING(cSavePath,LENGTH(cSavePath),1) <> "/" 
    THEN cSavePath = cSavePath + "/".
    
  END.
  
  iAttachment = 0.
  IF wm-image.in_ordnr > 0
  THEN DO:
    cRecordType = "wm-in_ord".
    cSubFolder  = STRING(wm-image.in_ordnr).
    FIND wm-in_ord WHERE
         wm-in_ord.companycode = wm-image.companycode
     AND wm-in_ord.IN_ordnr    = wm-image.in_ordnr
         NO-LOCK NO-ERROR.
    IF AVAIL wm-in_ord
    THEN iAttachment = wm-in_ord.attachmentnr.
  END.
  IF wm-image.out_ordnr > 0
  THEN DO:
    cRecordType = "wm-out_ord".
    cSubFolder  = STRING(wm-image.out_ordnr).
    FIND wm-out_ord WHERE
         wm-out_ord.companycode = wm-image.companycode
     AND wm-out_ord.out_ordnr    = wm-image.out_ordnr
         NO-LOCK NO-ERROR.
    IF AVAIL wm-out_ord
    THEN iAttachment = wm-out_ord.attachmentnr.
  END.
  
  cFilename = cSavePath + wm-image.relative_path.
  cOrgFile  = cFilename.
  iSeqnr    = 0.
  
  IF SEARCH(cFilename) <> ?
  THEN DO:
    RUN aa/proc/aa-save_attachment.p ( INPUT  iAttachment
                                      ,INPUT  cOrgFile
                                      ,INPUT-OUTPUT cFileName
                                      ,INPUT  cRecordType
                                      ,INPUT  cSubFolder
                                      ,OUTPUT iBlobNr
                                      ,OUTPUT cTargetFile
                                      ,OUTPUT cExtension
                                      ,OUTPUT cWarnings ).
    IF cWarnings = ""
    THEN DO:
      CREATE b-aa-attachment.
      ASSIGN b-aa-attachment.attachmentnr     = iAttachment
             b-aa-attachment.attachmenttype   = ""
             b-aa-attachment.recordtype       = cRecordType
             b-aa-attachment.filename         = cFilename
             b-aa-attachment.file_extension   = cExtension
             b-aa-attachment.target_filename  = cTargetFile
             b-aa-attachment.org_filename     = cOrgFile
             b-aa-attachment.remarks          = wm-image.remarks
             b-aa-attachment.blobnr           = iBlobNr
             b-aa-attachment.thumbnail-blobnr = 0
             b-aa-attachment.create_usercode  = "softpak"
             b-aa-attachment.dt_create        = wm-image.dt_create
             b-aa-attachment.tim_create       = wm-image.tim_create
             b-aa-attachment.update_usercode  = ""
             b-aa-attachment.dt_update        = ?
             b-aa-attachment.tim_update       = ""
             b-aa-attachment.ind_internet     = FALSE
             b-aa-attachment.ind_private      = FALSE
             b-aa-attachment.ind_template     = FALSE
             .
    END.
  END.
END.
