
/*------------------------------------------------------------------------
    File        : wm-1502-after-02-wm-control.p
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     : Thu May 21 09:59:29 CEST 2015
    Notes       :
  ----------------------------------------------------------------------*/

{system/conversion/conversion_progress.i}

DISABLE TRIGGERS FOR LOAD OF wm-control.

/* ***************************  Definitions  ************************** */

DEF VAR gcGroup    AS CHAR NO-UNDO INIT "wm-report".
DEF VAR gcSubGroup AS CHAR NO-UNDO INIT "parameter".
DEF VAR gcKey1     AS CHAR NO-UNDO INIT "wmrpcmb".

DEF VAR cProgram   AS CHAR NO-UNDO.
DEF VAR cAction    AS CHAR NO-UNDO.
DEF VAR cTable     AS CHAR NO-UNDO.
DEF VAR iTotal     AS INT  NO-UNDO.
DEF VAR iDone      AS INT  NO-UNDO.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "Load report parms into wm-control"
       iTotal   = 0
       iDone    = 0
       cTable   = "wm-control".

DEF TEMP-TABLE tt-reportparms
  FIELD rpname AS CHAR
  FIELD rpfile AS CHAR
  FIELD rppath AS CHAR.

/* ********************  Preprocessor Definitions  ******************** */


/* ***************************  Main Block  *************************** */

IF CAN-FIND (sp-control WHERE sp-control.controlkode = "WM-REPORT-CMB") THEN RETURN.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

RUN wmDelParmValues.
RUN wmGetParmFiles.
RUN wmSetParmValues.

/* **********************  Internal Procedures  *********************** */

PROCEDURE wmCount:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  iDone = iDone + 1.
  IF iDone MODULO 10 = 0
  THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END PROCEDURE.

PROCEDURE wmDelParmValues:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/

  FOR EACH wm-control WHERE wm-control.controlgroup    = gcGroup
                        AND wm-control.controlsubgroup = gcSubGroup
                        AND wm-control.controlkey1     = gcKey1 EXCLUSIVE-LOCK.
    RUN wmCount.
    DELETE wm-control.
  END.

END PROCEDURE.

PROCEDURE wmGetParmFiles:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/

  DEF VAR iPropath AS INT  NO-UNDO.
  DEF VAR cPropath AS CHAR NO-UNDO.

  FOR EACH sp-client NO-LOCK.
    RUN wmLoadParmFiles (sp-client.systempath).
  END.

  DO iPropath = 1 TO NUM-ENTRIES (PROPATH).
    cPropath = ENTRY (iPropath, PROPATH).
    IF INDEX (cPropath, "oesp") > 0 THEN RUN wmLoadParmFiles (cPropath).
  END.

/*  RUN wmLoadParmFiles ('propath').*/
END PROCEDURE.


PROCEDURE wmLoadParmFiles:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pcRoot AS CHARACTER NO-UNDO.

  DEF VAR cParmFolder AS CHAR   NO-UNDO INIT "wm/report/parameters".
  DEF VAR cFolder     AS CHAR   NO-UNDO.
  DEF VAR cFile       AS CHAR   NO-UNDO.
  DEF VAR cParm       AS CHAR   NO-UNDO.

  IF pcRoot = "propath" THEN cFolder = cParmfolder.
  ELSE cFolder = SUBSTITUTE ("&1/&2", pcRoot, cParmFolder).
  FILE-INFO:FILE-NAME = cFolder NO-ERROR.
  IF FILE-INFO:FILE-TYPE EQ ? THEN RETURN.
  IF NOT FILE-INFO:FILE-TYPE MATCHES "*D*" THEN RETURN.

  INPUT FROM OS-DIR (cFolder).
  REPEAT.
    IMPORT cFile.
    RUN wmCount.
    IF cFile BEGINS "." THEN NEXT.
    IF NUM-ENTRIES(cFile, ".") > 2 THEN NEXT.
    IF NUM-ENTRIES(cFile, ".") EQ 2 AND ENTRY (2, cFile, ".") <> "txt" THEN NEXT.
    FILE-INFO:FILE-NAME = cFolder + "/" + cFile NO-ERROR.
    IF FILE-INFO:FILE-TYPE EQ ? THEN NEXT.
    IF NOT FILE-INFO:FILE-TYPE MATCHES "*F*" THEN NEXT.
    FIND FIRST tt-reportparms WHERE tt-reportparms.rpfile = cFile NO-ERROR.
    IF NOT AVAIL tt-reportparms THEN
    DO.
      CREATE tt-reportparms.
      ASSIGN tt-reportparms.rpfile = cFile
             tt-reportparms.rpname = ENTRY (1, cFile, ".")
             tt-reportparms.rppath = FILE-INFO:FULL-PATHNAME.
    END.
  END.
  INPUT CLOSE.

END PROCEDURE.

PROCEDURE wmSetParmValues:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/

  DEF VAR cParm  AS CHAR   NO-UNDO.
  DEF VAR cItem  AS CHAR   NO-UNDO.
  DEF VAR cValue AS CHAR   NO-UNDO.

  trans-block:
  DO TRANSACTION ON ERROR  UNDO, LEAVE
                 ON STOP   UNDO, LEAVE
                 ON ENDKEY UNDO, LEAVE.

    FOR EACH tt-reportparms ON ERROR  UNDO trans-block, LEAVE trans-block
                            ON STOP   UNDO trans-block, LEAVE trans-block
                            ON ENDKEY UNDO trans-block, LEAVE trans-block.
      RUN wmCount.
      cValue = "".
      INPUT FROM VALUE (tt-reportparms.rppath).
      REPEAT.
        IMPORT UNFORMATTED cItem.
        IF TRIM(cItem) NE ""
        THEN cValue = cValue + (IF cValue EQ "" THEN "" ELSE CHR(10)) + TRIM (cItem).
      END.
      INPUT CLOSE.

      IF cValue <> "" THEN
      DO.
        CREATE wm-control.
        ASSIGN wm-control.controlname     = tt-reportparms.rpname
               wm-control.controlkey1     = gcKey1
               wm-control.controlkey2     = ""
               wm-control.controlkey3     = ""
               wm-control.controlkey4     = ""
               wm-control.controlkey5     = ""
               wm-control.controlvalue    = cValue
               wm-control.controlgroup    = gcGroup
               wm-control.controlsubgroup = gcSubGroup.
      END.
    END.

    CREATE sp-control.
    ASSIGN sp-control.controlkode = "WM-REPORT-CMB"
           sp-control.lijst-2     = "COVERSIE 15.02 EN HOGER".
  END.

END PROCEDURE.




