

&IF defined(DEBUG) > 0 &THEN
  PROCEDURE displayProgress.
    DEF INPUT PARAM pcProgram AS CHAR NO-UNDO.
    DEF INPUT PARAM pcAction  AS CHAR NO-UNDO.
    DEF INPUT PARAM pcTable   AS CHAR NO-UNDO.
    DEF INPUT PARAM piTotal   AS INT  NO-UNDO.
    DEF INPUT PARAM piDone    AS INT  NO-UNDO.
  END PROCEDURE.
&ELSE
 {System/conversion/conversion_progress.i}
&ENDIF

DEFINE VARIABLE cProgram   AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction    AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable     AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal     AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone      AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel       AS INTEGER   NO-UNDO.

DEF VAR lNoBookingOnClosingdaysPlusOne AS LOG  NO-UNDO.
DEF VAR sp-companycode                 AS CHAR NO-UNDO.
  
DEF BUFFER b-wm-timeslot_setting FOR wm-timeslot_setting.
  
DISABLE TRIGGERS FOR LOAD OF b-wm-timeslot_setting.

/* ************************  Function Prototypes ********************** */
    
FUNCTION wmGetGenericParameter RETURNS CHARACTER
   (INPUT pcCompanycode    AS CHAR, 
    INPUT pcParameterGroup AS CHAR,
    INPUT pcParameterName  AS CHAR) FORWARD.

    
/* *********************** main block ********************************* */  
 
ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert timeslot settings"
  cTable   = "wm-ssd"
  iTotal   = 0
  iDone    = 0.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FOR EACH sp-company NO-LOCK.
  sp-companycode                 = sp-company.companycode.
  lNoBookingOnClosingdaysPlusOne = wmGetGenericParameter(?, "SSD", "NoBookingOnClosingdaysPlusOne") EQ "YES".
  
  FIND b-wm-timeslot_setting WHERE b-wm-timeslot_setting.companycode           = sp-companycode 
                               AND b-wm-timeslot_setting.loc_terminalgroupcode = "" EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
  IF AVAIL b-wm-timeslot_setting THEN ASSIGN b-wm-timeslot_setting.in_ind_block_tomorrow_on_closed  = lNoBookingOnClosingdaysPlusOne
                                             b-wm-timeslot_setting.out_ind_block_tomorrow_on_closed = lNoBookingOnClosingdaysPlusOne.                             
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.


/* **********************  Internal Procedures  *********************** */

/* ************************  Function Implementations ***************** */

FUNCTION wmGetGenericParameter RETURNS CHARACTER
   (INPUT pcCompanycode    AS CHAR, 
    INPUT pcParameterGroup AS CHAR,
    INPUT pcParameterName  AS CHAR):
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/  
  DEF VAR cValue       AS CHAR NO-UNDO.
  DEF VAR cCompanyCode AS CHAR NO-UNDO.
  
  cCompanyCode = pcCompanyCode.
  IF cCompanyCode = ? THEN cCompanyCode = sp-companycode.

  FIND wm-parameter_generic WHERE wm-parameter_generic.companycode     = cCompanyCode
                              AND wm-parameter_generic.parameter_group = pcParameterGroup
                              AND wm-parameter_generic.parameter_name  = pcParameterName NO-LOCK NO-ERROR.
  IF AVAIL wm-parameter_generic THEN
  DO.
    IF NOT wm-parameter_generic.ind_inactive THEN 
    DO.
      cValue = wm-parameter_generic.parameter_value.
      IF cValue EQ "" THEN cValue = wm-parameter_generic.parameter_initial_value.
    END.
  END.
    
  RETURN cValue.
      
END FUNCTION.


